<script lang="ts" setup>
import type { BaseLink } from '@/types/base';
import type { MainNavigationLevelOneItems } from '@/types/navigation';
import { ArrowRight, ChevronLgRight } from 'slippers-ui/icons';

// Define Props
defineProps<{
  lists?: MainNavigationLevelOneItems['lists'];
  title?: string;
  feature?: MainNavigationLevelOneItems['feature'];
  link?: BaseLink;
  config: MainNavigationLevelOneItems['config'];
}>();
</script>

<template>
  <div class="navigation-dropdown-list">
    <div class="navigation-dropdown-list__wrapper">
      <div v-if="lists" class="navigation-dropdown-list__sections">
        <section v-for="list in lists" :key="list?.title" class="navigation-dropdown-list__section">
          <header v-if="list.title">
            <SlpTypography tag="span" variant="body2-bold" class="navigation-dropdown-list__title">
              {{ list.title }}
            </SlpTypography>
          </header>
          <ul class="navigation-dropdown-list__list">
            <li v-for="item in list.items" :key="item.text" class="navigation-dropdown-list__item">
              <a
                class="navigation-dropdown-list__popover-link"
                :href="item.config.href"
                :data-ga-name="item.config.dataGaName"
                :data-ga-location="item.config.dataGaLocation"
                :data-nav-levelone="config.dataNavLevelOne"
                :data-nav-leveltwo="item.config.dataGaName"
              >
                <SlpTypography tag="span" variant="body2">{{ item.text }} </SlpTypography>
              </a>
            </li>
          </ul>
        </section>
      </div>
      <SlpButton
        v-if="link"
        class="navigation-dropdown-list__bottom-link"
        variant="tertiary"
        :href="link.config.href"
        :data-ga-name="link.config.dataGaName"
        :data-ga-location="link.config.dataGaLocation"
        :data-nav-levelone="config.dataNavLevelOne"
        :data-nav-leveltwo="link.config.dataGaName"
      >
        {{ link.text }}

        <SlpIcon :icon="ChevronLgRight" size="sm" class="slp-ml-8" />
      </SlpButton>
    </div>

    <section
      v-if="feature"
      class="navigation-dropdown-list__feature"
      :style="`--backgroundColor: ${feature.backgroundColor}; --textColor: ${feature.textColor}`"
    >
      <article class="navigation-dropdown-list__feature__article">
        <a
          :href="feature.link.config.href"
          :data-ga-name="feature.link.config.dataGaName"
          :data-ga-location="feature.link.config.dataGaLocation"
          :data-nav-levelone="config.dataNavLevelOne"
          :data-nav-leveltwo="feature.link.config.dataGaName"
          class="navigation-dropdown-list__feature__link"
        >
          <header v-if="feature.title" class="navigation-dropdown-list__feature__title slp-mb-8">
            <SlpTypography tag="span" variant="body2-bold">
              {{ feature.title }}
            </SlpTypography>
          </header>
          <section class="navigation-dropdown-list__feature__content">
            <div v-if="feature.image" class="navigation-dropdown-list__image">
              <img
                :src="feature.image.config.src"
                :alt="feature.image.altText"
                loading="lazy"
                format="webp"
                quality="99"
              />
            </div>
            <div class="navigation-dropdown-list__feature-desc">
              <SlpTypography tag="p" variant="body1" class="slp-mb-8">
                {{ feature.text }}
              </SlpTypography>
            </div>
            <SlpButton class="navigation-dropdown-list__side-link" variant="tertiary">
              {{ feature.link.text }}
              <SlpIcon :icon="ArrowRight" size="sm" class="slp-ml-8" />
            </SlpButton>
          </section>
        </a>
      </article>
    </section>
  </div>
</template>

<style lang="scss" scoped>
.navigation-dropdown-list {
  @media (min-width: $breakpoint-lg) {
    display: flex;
  }

  &__wrapper {
    @media (min-width: $breakpoint-lg) {
      flex-wrap: wrap;
      display: flex;
      padding: 24px;
    }
  }

  &__sections {
    @media (min-width: $breakpoint-lg) {
      display: flex;
      gap: 16px;
    }
  }

  &__section {
    break-inside: avoid;
    display: flex;
    flex-direction: column;
    margin: 0 16px;
    min-width: 170px;
    page-break-inside: avoid;
    margin-top: 24px;
    gap: 16px;

    @media (min-width: $breakpoint-lg) {
      margin: 0;
    }
    @media (min-width: $breakpoint-xl) {
      margin: 0 8px;
    }
  }

  &__feature {
    display: block;
    background-color: var(--backgroundColor, #fff);
    color: var(--textColor, #171321);
    position: relative;
    padding: 24px;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    white-space: normal;

    > * {
      position: relative;
    }

    &:before {
      content: '';
      background-color: var(--backgroundColor, #fff);
      position: absolute;
      height: calc(100% + 2px);
      width: calc(100% + 2px);
      top: -1px;
      left: 0;
      border-radius: 0 4px 4px 0;
    }

    &__article,
    &__content {
      color: var(--textColor, #171321);
      height: 100%;
      display: flex;
      flex-direction: column;
      white-space: normal;
      justify-content: space-between;

      a {
        height: 100%;
        height: 100%;
        display: flex;
        flex-direction: column;
        white-space: normal;
        justify-content: space-between;

        .navigation-dropdown-list__side-link {
          text-decoration: none;
          text-align: left;

          :deep(svg) {
            * {
              fill: currentColor;
            }
          }
        }

        &:hover {
          .navigation-dropdown-list__side-link {
            text-decoration: none;

            &:deep(svg) {
              transform: translateX(8px);
            }
          }
        }
      }
    }

    &__title,
    &__title span {
      color: $color-text-link-100;
    }
  }

  &__side-link {
    color: var(--textColor, #171321);
  }

  &__item {
    border-bottom: 1px solid #d1d0d3;
    padding: 12px 0 !important;

    @media (min-width: $breakpoint-lg) {
      border-bottom: 0;
      margin: 0;
      padding: 8px 0 !important;
    }

    :deep(span) {
      font-size: 18px;
      font-weight: 400;
      line-height: 28px;

      @media (min-width: $breakpoint-lg) {
        font-size: 16px;
        line-height: 24px;
      }
    }

    :deep(a) {
      color: $color-text-300;

      &:hover {
        color: $color-text-link-100;
      }
    }
  }

  &__title {
    color: $color-text-link-100;
    margin: 24px 16px 16px;

    @media (min-width: $breakpoint-lg) {
      margin: 8px 0 0;
    }
  }

  &__list {
    padding-left: 16px;

    @media (min-width: $breakpoint-lg) {
      padding-left: 0;
    }
  }

  &__bottom-link {
    margin: 16px 32px 16px;

    @media (min-width: $breakpoint-lg) {
      margin: 11px 0 0px;
    }
    @media (min-width: $breakpoint-xl) {
      margin: 11px 8px 0px;
    }
  }

  &__image {
    width: 100%;
    margin-bottom: $spacing-16;
    max-width: 375px;

    @media (min-width: $breakpoint-lg) {
      max-width: 200px;
      width: 200px;
      height: 160px;
    }

    @media (min-width: $breakpoint-xl) {
      width: 239px;
      max-width: 239px;
    }

    img {
      width: 100%;
      height: 100%;
    }
  }

  &__feature-desc {
    margin: 32px 0;

    @media (min-width: $breakpoint-lg) {
      margin: 0 0 8px 0;
    }
  }
}
</style>
